//+------------------------------------------------------------------+
//|   TRO_MasterCandle_Plot                                          |
//|                                                                  | 
//|   Copyright  2009, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|   All my indicators should be considered donationware. That is   |
//|   you are free to use them for your personal use, and are        |
//|   under no obligation to pay for them. However, if you do find   |
//|   this or any of my other indicators help you with your trading  |
//|   then any Gift or Donation as a show of appreciation is         |
//|   gratefully accepted.                                           |
//|                                                                  |
//|   Gifts or Donations also keep me motivated in producing more    |
//|   great free indicators. :-)                                     |
//|                                                                  |
//|   PayPal - THERUMPLEDONE@GMAIL.COM                               |  
//+------------------------------------------------------------------+ 
//| Use http://therumpledone.mbtrading.com/fx/ as your forex broker  |  
//| ...tell them therumpledone sent you!                             |  
//+------------------------------------------------------------------+ 


#property  copyright "Copyright  2009, Avery T. Horton, Jr. aka TRO" 
#property  link      "http://www.therumpledone.com/" 

#property indicator_chart_window 
#property indicator_buffers 0

extern bool   Sound.Alert  = false ;
extern bool   Use.Wicks    = true ;
extern bool   Show.Comment = true ;

//extern bool   Show.PriceBox  = true ;
//extern int    myBoxWidth  = 3;

extern color colorIBHigh    = HotPink ;
extern color colorIBLow     = HotPink ;
extern color colorIBTarget  = Green ;

extern int BarsAgo   = 24 ;
extern int myPeriod  = 0 ;

extern double myRiskReward  = 1.5 ;

//---- buffers
 

string tHIGH0  = "mcHIGH_0" ;
string tLOW0   = "mcLOW_0" ;
string tTarget = "mcTarget" ; 

string symbol, tChartPeriod,  short_name, oldmsg = "" ;  
int    digits, period  ; 

double xRange, xPct, X01, X02, close, min=99999, max=-1, Open0, Open1, Open2, Close0, Close1, Close2, High0, High1, High2, Low0,  Low1, Low2  ;
double Open4, Open5, Open3, Close4, Close5, Close3, High4, High5, High3, Low4,  Low5, Low3  ;

double  point, target ;


bool IB = false, bTarget = false ; 
 
int xIB ; 
 
datetime Trigger, CurrentTime ; 
 
double M1_Open ; 
 
//+------------------------------------------------------------------+
int init()
  {
 
   symbol       = Symbol() ;
   digits       =  Digits ;
   point        =  Point ;

   if(digits == 5 || digits == 3) { digits  = digits - 1 ; point = point * 10 ; } 
      
   if(myPeriod == 0) { period = Period() ; } else { period = myPeriod ; }    
   
   tChartPeriod =  TimeFrameToString(period) ;   
   
   string short_name="mcPL";
   IndicatorShortName(short_name);

   deinit() ;
   
   return(0);
  }
  


//+------------------------------------------------------------------+

void ObDeleteObjectsByPrefix(string Prefix)
  {
   int L = StringLen(Prefix);
   int i = 0; 
   while(i < ObjectsTotal())
     {
       string ObjName = ObjectName(i);
       if(StringSubstr(ObjName, 0, L) != Prefix) 
         { 
           i++; 
           continue;
         }
       ObjectDelete(ObjName);
     }
  }
    
//+------------------------------------------------------------------+
int deinit()
  {
        
   ObDeleteObjectsByPrefix("mc" );  
   TRO() ;
   return(0);
  }
  
  
//+------------------------------------------------------------------+
int start()
{

CurrentTime = TimeMinute(TimeCurrent()) ;
Comment( "" );

   int i, dayi, counted_bars = IndicatorCounted();
//---- check for possible errors
   if(counted_bars < 0) 
       return(-1);
//---- last counted bar will be recounted
   if(counted_bars > 0) 
       counted_bars--;  
   int limit = Bars - counted_bars;
//----   
   for(i = 0; i < BarsAgo ; i++)
   {
 
   IB  = false ; 
   IB  = bTarget ;
	xIB = 0 ;
			
	Close0 = iClose(symbol,period,i) ; 
   Close1 = iClose(symbol,period,i+1) ;    
   Close2 = iClose(symbol,period,i+2) ;  
     
   Open0 = iOpen(symbol,period,i) ; 
   Open1 = iOpen(symbol,period,i+1) ;    
   Open2 = iOpen(symbol,period,i+2) ;  

   High0 = iHigh(symbol,period,i) ; 
   High1 = iHigh(symbol,period,i+1) ;    
   High2 = iHigh(symbol,period,i+2) ; 

   Low0 = iLow(symbol,period,i) ; 
   Low1 = iLow(symbol,period,i+1) ;    
   Low2 = iLow(symbol,period,i+2) ;  		

	Close4 = iClose(symbol,period,i+4) ; 
   Close5 = iClose(symbol,period,i+5) ;    
   Close3 = iClose(symbol,period,i+3) ;  
     
   Open4 = iOpen(symbol,period,i+4) ; 
   Open5 = iOpen(symbol,period,i+5) ;    
   Open3 = iOpen(symbol,period,i+3) ;  

   High4 = iHigh(symbol,period,i+4) ; 
   High5 = iHigh(symbol,period,i+5) ;    
   High3 = iHigh(symbol,period,i+3) ; 

   Low4 = iLow(symbol,period,i+4) ; 
   Low5 = iLow(symbol,period,i+5) ;    
   Low3 = iLow(symbol,period,i+3) ;  	

   
   max = MathMax(max,High0) ;   			
   min = MathMin(min,Low0) ;   				
			
   if( High5 > High1 &&  Low5 < Low1 &&
       High5 > High2 &&  Low5 < Low2 &&
       High5 > High3 &&  Low5 < Low3 &&
       High5 > High4 &&  Low5 < Low4 )  
   { 
      IB  = true ; 
      if( Use.Wicks ) { X01 = High5 ; X02 = Low5 ; } else { X01 = Open5 ; X02 = Close5 ; } 
      xIB = i+5 ;   
      xRange =  ( High5 - Low5 ) ;
      
      if(Show.Comment)
      {
      Comment( "Most recent " + tChartPeriod + " master candle was " + xIB + " bars ago" + "\n",
               "MC Range = " + DoubleToStr(xRange / point ,0)  + 
               "  Risk/Reward = " + DoubleToStr(myRiskReward ,2)                
               ) ;
      }
      break ; 
   }

   }

  if(!IB) { deinit() ; } 

  if (ObjectFind(tHIGH0) != 0)
      {
      
          ObjectCreate(tHIGH0,OBJ_HLINE,0,Time[0],X01);         
          ObjectSet(tHIGH0,OBJPROP_COLOR,colorIBHigh);  
      } 
      else
      {
         ObjectMove(tHIGH0,0,Time[0],X01);
      }
 

    
    if (ObjectFind(tLOW0) != 0)
      {
          ObjectCreate(tLOW0,OBJ_HLINE,0,Time[0],X02);   
          ObjectSet(tLOW0,OBJPROP_COLOR,colorIBLow);
      } 
      else
      {
         ObjectMove(tLOW0,0,Time[0],X02);
      } 


    if(Ask >= X01 ) { target = X01 + (xRange * myRiskReward) ; bTarget = true ; }
    if(Bid <= X02 ) { target = X02 - (xRange * myRiskReward) ; bTarget = true ; }    
 
 
   if(bTarget)
   {    
    if (ObjectFind(tTarget) != 0)
      {
          ObjectCreate(tTarget,OBJ_HLINE,0,Time[0],target);   
          ObjectSet(tTarget,OBJPROP_COLOR,colorIBTarget);
      } 
      else
      {
         ObjectMove(tTarget,0,Time[0],target);  
      }
   }
   else
   {
         ObjectDelete(tTarget); 
   }


   M1_Open = iOpen(symbol,PERIOD_M1,0) ; 
	close   = iClose(symbol,period,0) ; 

if ( Trigger != CurrentTime &&  Sound.Alert ) 
{
   if( M1_Open < X01 && close >= X01 ) { Trigger = CurrentTime ; Alert(symbol,"  ", tChartPeriod, " MC Long Triggered "+ DoubleToStr(X01 ,digits)); }
   if( M1_Open > X02 && close <= X02 ) { Trigger = CurrentTime ; Alert(symbol,"  ", tChartPeriod, " MC Short Triggered "+ DoubleToStr(X02 ,digits)); }     
}


//   if(Show.PriceBox) { DoBox() ; }

return(0);
}


//+------------------------------------------------------------------+

string TimeFrameToString(int tf)
{
   string tfs;
   switch(tf) {
      case PERIOD_M1:  tfs="M1"  ; break;
      case PERIOD_M5:  tfs="M5"  ; break;
      case PERIOD_M15: tfs="M15" ; break;
      case PERIOD_M30: tfs="M30" ; break;
      case PERIOD_H1:  tfs="H1"  ; break;
      case PERIOD_H4:  tfs="H4"  ; break;
      case PERIOD_D1:  tfs="D1"  ; break;
      case PERIOD_W1:  tfs="W1"  ; break;
      case PERIOD_MN1: tfs="MN";
   }
   return(tfs);
}


//+------------------------------------------------------------------+  
void TRO()
{   
   
   string tObjName03    = "TROTAG"  ;  
   ObjectCreate(tObjName03, OBJ_LABEL, 0, 0, 0);//HiLow LABEL
   ObjectSetText(tObjName03, CharToStr(78) , 12 ,  "Wingdings",  DimGray );
   ObjectSet(tObjName03, OBJPROP_CORNER, 3);
   ObjectSet(tObjName03, OBJPROP_XDISTANCE, 5 );
   ObjectSet(tObjName03, OBJPROP_YDISTANCE, 5 );  
}
//+------------------------------------------------------------------+
/*

  if (ObjectFind(tHIGH0) != 0)
      {
          
          ObjectCreate(tHIGH0,OBJ_TREND,Time[xIB],X01,Time[0],X01);         
          ObjectSet(tHIGH0,OBJPROP_COLOR,colorIBHigh);
          ObjectSet(tHIGH0,OBJPROP_RAY,false);  
          ObjectMove(tHIGH0,0,Time[xIB],X01);
          ObjectMove(tHIGH0,1,Time[0],X01);           
      } 
      else
      {
         ObjectMove(tHIGH0,0,Time[xIB],X01);
         ObjectMove(tHIGH0,1,Time[0],X01);    
 
      }
 
   
    
    if (ObjectFind(tLOW0) != 0)
      {
          ObjectCreate(tLOW0,OBJ_TREND,Time[xIB],X02,Time[0],X02);         
          ObjectSet(tLOW0,OBJPROP_COLOR,colorIBLow);
          ObjectSet(tLOW0,OBJPROP_RAY,false);  
          ObjectMove(tLOW0,0,Time[xIB],X02);
          ObjectMove(tLOW0,1,Time[0],X02);            
                
      } 
      else
      {
         ObjectMove(tLOW0,0,Time[xIB],X02);
         ObjectMove(tLOW0,1,Time[0],X02);  
      }


//+--------- TRO MODIFICATION ---------------------------------------+  
void DoBox()    
{


       if (ObjectFind(short_name+"01") != 0)
      {
          ObjectCreate(short_name+"01",OBJ_ARROW,0,Time[0],X01);
          ObjectSet(short_name+"01",OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
          ObjectSet(short_name+"01",OBJPROP_COLOR,colorIBHigh);  
          ObjectSet(short_name+"01",OBJPROP_WIDTH,myBoxWidth);  
      } 
      else
      {
         ObjectMove(short_name+"01",0,Time[0],X01);
         ObjectSet(short_name+"01",OBJPROP_COLOR,colorIBHigh);  
      }

       if (ObjectFind(short_name+"02") != 0)
      {
          ObjectCreate(short_name+"02",OBJ_ARROW,0,Time[0],X02);
          ObjectSet(short_name+"02",OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
          ObjectSet(short_name+"02",OBJPROP_COLOR,colorIBLow);  
          ObjectSet(short_name+"02",OBJPROP_WIDTH,myBoxWidth);  
      } 
      else
      {
         ObjectMove(short_name+"02",0,Time[0],X02);
         ObjectSet(short_name+"02",OBJPROP_COLOR,colorIBLow);  
      }

}
      
*/